# ifndef __GenAnneal__H
# define __GenAnneal__H
# include <problem.h>
# include <population.h>
# include <rlsprogram.h>
# include <tolmin.h>
# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <grs.h>
# include <vector>
using namespace std;

class	GenAnneal
{
	private:
		Problem *problem;
		Data x,xopt,c;
		double rt,eps,t,fopt;
		int ns, nt, neps;
		Population *pop;
		RlsProgram *program;
		Grs *Solver;
	public:
		GenAnneal(Problem *p);
		void	setRT(double r);
		double	getRT() const;
		void	setEPS(double e);
		double	getEPS() const;
		void	setT(double T);
		double	getT() const;
		void	setNEPS(int n);
		int	getNEPS() const;
		double	getMinimum();
		double	getMinimum(Data &xx);
		void	Solve();
		~GenAnneal();
};

# endif
